<template>
<div class="errorContainer">
  <b-alert v-if="alertConfig==undefined" v-model="showDismissibleAlert"
        :variant="variant" dismissible fade>
      <span v-if="isError">Une erreur est survenue:<br/></span>
      <span v-html="message"></span>
    </b-alert>
  <b-alert v-else :show="alertConfig.autoHide ? dismissCountDown:showDismissibleAlert"
        @dismissed="dismissCountDown=0"
        @dismiss-count-down="countDownChanged" :dismissible="alertConfig.closable"
        :variant="alertConfig.type" fade>
      <span v-html="message"></span> <span v-if="alertConfig.autoHide">({{ dismissCountDown }})</span>
    </b-alert>
</div>
</template>

<script lang="ts">
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import { EventBus, EVENTS } from '@/services/EventBus';
import Component from 'vue-class-component';
import BaseComponent from '../BaseComponent';
import AlertMessage from '../../models/shared/AlertMessage';

@Component({
  props: {
  },
})
export default class AlertPanel extends BaseComponent {
  message='';

  showDismissibleAlert=false;

  variant = 'danger';

  dismissCountDown = 10;

  alertConfig!:AlertMessage|undefined;

  mounted() {
    EventBus.$on(EVENTS.ERROR, (error:any) => this.onError(error));
    EventBus.$on(EVENTS.WARNING, (message:AlertMessage) => this.onWarning(message));
    EventBus.$on(EVENTS.INFO, (error:any) => this.onInfo(error));
  }

  onError(error:any) {
    this.alertConfig = undefined;
    console.log(error);
    if (error === '') {
      this.showDismissibleAlert = false;
    } else {
      this.variant = 'danger';
      this.message = `${error}`;
      this.showDismissibleAlert = true;
    }
  }

  countDownChanged(dismissCountDown:any) {
    if (this.alertConfig && this.alertConfig.autoHide) {
      this.dismissCountDown = dismissCountDown;
    }
  }

  onWarning(message: AlertMessage) {
    this.message = message.label;
    this.alertConfig = message;
    this.dismissCountDown = message.countDown;
    this.showDismissibleAlert = true;
  }

  onInfo(error:any) {
    this.alertConfig = undefined;
    console.log(error);
    if (error === '') {
      this.showDismissibleAlert = false;
    } else {
      this.variant = 'success';
      this.message = `${error}`;
      this.showDismissibleAlert = true;
    }
  }

  get isError() {
    return this.variant === 'danger';
  }
}
</script>

<style scoped lang="less">
.errorContainer{
  position: absolute;
  top: 64px;
  width: 40%;
  left: 30%;
  z-index: 800000;
  box-shadow:0 1px 3px rgba(0, 0, 0, 0.12), 0 -1px 5px rgba(0, 0, 0, 0.24);
}
.alert{
  margin:0px;
}
</style>
